package algorithms.geneticAlgorithm.Components;

import java.util.ArrayList;
import java.util.Random;

public abstract class GACrossoverStrategy<I extends GAIndividual> {
	
	protected double crossProb;
	protected Random rng;
	
	public GACrossoverStrategy(double prob){
		crossProb = prob;
		rng = new Random();
	}
	
	public GACrossoverStrategy(){
		crossProb = 0.7;
		rng = new Random();
	}
	
	public abstract ArrayList<I> crossOver(ArrayList<I> parents);
		
	public void setCrossoverProbability(double prob){
		crossProb = prob;
	}
	
	public double getCrossoverProbability(){
		return crossProb;
	}
	
}
